package friendlist;
/**
 * Interface, dass jede Freundesliste implementieren muss.
 * Fertig implementiert.
 * @author Ben
 */

public interface FreundesListeI {

	/**
	 *
	 * @return Anzahl an Freunden
	 */
	public int getAnzahl();
	
	/**
	 * 
	 * @return Maximale Anzahl an erlaubten Freunden
	 */
	public int getMaxAnzahl();
	
	/**
	 * Ändert die maximale Anzahl an Freunden. Die Zahl darf nicht weniger als 1 sein.
	 * @param amount wird zu der aktuellen Anzahl hinzuaddiert.
	 * @return getMaxAnzahl()+amount < 1
	 */
	public boolean addAnzahl(int amount);
	
	/**
	 * Fügt den Freund "name" zur aktuellen Freundesliste
	 * @param name Name des Freundes
	 * @return isFreund() bevor er hinzugefügt wurde.
	 */
	public boolean addFreund(String name);
	
	/**
	 * Prüft, ob der Freund "name" in der Freundesliste enthalten ist
	 * @param name Name des Freundes
	 * @return true, wenn vorhanden, false falls nicht
	 */
	public boolean isFreund(String name);
	
	/**
	 * gibt alle Freunde in der Liste als Array zurück. 
	 * @return eine Liste von Freunden als String Array
	 */
	public String[] getFreunde();
	
}
