package friendlist.client;

import org.junit.runner.JUnitCore;
import org.junit.runner.Result;

import friendlist.FreundesListeI;
import friendlist.test.FreundesListeT;

/**
 * Diese Klasse ist nur ein Stub und leitet jeden Methodenaufruf an den Server
 * weiter, wartet auf eine Antwort, interpretiert diese und gibt das
 * entsprechende Ergebnis zurück
 * 
 * @author Ben
 */
public class FreundesListeC implements FreundesListeI {

	/**
	 * Kümmert sich um die Netzwerkkommunikation
	 */
	FreundeslisteC2 proxy;

	/**
	 * Defaultkonstruktor versucht sein Glück mit Standardwerten
	 * 
	 * @throws Exception
	 */
	public FreundesListeC() throws Exception {
		// Versuche standard optionen
		this("127.0.0.1", 30003);
	}

	/**
	 * Konstruktor, der die benötigten Informationen bekommt um eine
	 * Netzwerkverbindugn zum Server aufzubauen
	 * 
	 * @param ip
	 *            Ip des Servers
	 * @param port
	 *            Port des Server
	 * @throws Exception
	 *             falls Verbindung fehlschlägt
	 */
	public FreundesListeC(String ip, int port) throws Exception {
		// TODO stelle TCP Verbindung zum Server her und leite alle
		proxy = new FreundeslisteC2(ip, port);
		// Methodenaufrufe weiter
		// wenn Verbindung nicht klappt, wirf eine Exception
	}

	/**
	 * Beispielhafte implementation
	 */
	public boolean addAnzahl(int amount) {

		// TODO
		// verbindung steht bereits
		// verschicke anfrage string an server
		// warte auf antwort
		String answer = proxy.requestServer("addAnzahl,5");
		// werte antwort aus und liefere ergebnis
		return answer.equals("true");
	}

	public boolean addFreund(String name) {
		return false;
	}

	public int getAnzahl() {
		return 0;
	}

	public String[] getFreunde() {
		return null;
	}

	public int getMaxAnzahl() {
		return 0;
	}

	public boolean isFreund(String name) {
		return false;
	}

	/**
	 * Proxy für die Vertreterklasse, hält TCP Verbindung aufrecht und weiß wie
	 * man mit dem Server kommunizieren muss.
	 * 
	 * @author Ben
	 */
	class FreundeslisteC2 {

		int listennr = -1;

		public FreundeslisteC2(String ip, int port) throws Exception {
			// Stelle Verbindung her
			// übermittel anfrage "neue liste gefordert"
			// entnehme der antwort die listennr und speicher diese
			// diese sollte bei jeder anfrage dabei sein, damit der server weiß
			// welche liste gemeint ist
		}

		String requestServer(String request) {
			// Schritt 1: werte Request aus. Welche Methode und welche
			// Argumente?
			// Schritt 2: erzeuge String, so dass der Server weiß was er zu tun
			// hat.
			// Schritt 3: übermittel Request an Server, warte auf antwort ab und
			// Schritt 5: interpretiere antwort und gebe ein passendes ergebnis
			// zurück
			return "";
		}
	}

}
