/**
 * 
 */
package friendlist.test;

import static org.junit.Assert.*;

import org.junit.Test;
import org.junit.runner.JUnitCore;
import org.junit.runner.Result;
import org.junit.runner.notification.Failure;

import friendlist.FreundesListeI;
import friendlist.client.FreundesListeC;
import friendlist.server.FreundesListeS;

/**
 * Testklasse für Freundeslisten. Diese Klasse soll prüfen, ob sich die Klasse
 * FreundeslisteC genauso verhält wie die Klasse FreundeslisteS. Bitte
 * implementieren Sie alle fehlenden Testmethoden und erweitern Sie die
 * vorhandenen.
 * 
 * @author Ben
 * 
 */
public class FreundesListeT {

	static public String ip = "127.0.0.1";
	static public int port = 30003;

	/**
	 * Um den Test aus der Kommandozeile heraus zu starten, wird einfach diese
	 * Mainmethode aufgerufen
	 * 
	 * @param args 
	 *            0 = test, 1 = ip, 2 = port
	 */
	public static void main(String[] args) {
		if (args.length == 3) {
			ip = args[1];
			port = Integer.parseInt(args[2]);
		}

		Result x = JUnitCore.runClasses(new Class[] { FreundesListeT.class });
		for (Failure s : x.getFailures()) {
			System.out.println(s);
		}
	}

	/**
	 * Test method for {@link friendlist.FreundeslisteC#addAnzahl(int)}.
	 */
	@Test
	public void testAddAnzahl() throws Exception {
		fail("not implemented yet");

	}

	/**
	 * Test method for
	 * {@link friendlist.FreundeslisteC#addFreund(java.lang.String)}.
	 * 
	 * @throws Exception
	 */
	@Test
	public void testAddFreund() throws Exception {
		fail("not implemented yet");
	}

	/**
	 * Test method for {@link friendlist.FreundeslisteC#getAnzahl()}.
	 * 
	 * @throws Exception
	 */
	@Test
	public void testGetAnzahl() throws Exception {
		FreundesListeI fl1 = new FreundesListeC(ip, port);
		FreundesListeI fl2 = new FreundesListeS();
		for (int i = 0; i < 5000; i++) {
			String freund = Math.random() * Math.random() + "";
			fl1.addFreund(freund);
			fl2.addFreund(freund);
			assertTrue("Anzahl falsch", fl1.getAnzahl() == fl2.getAnzahl());
		}
	}

	/**
	 * Test method for {@link friendlist.FreundeslisteC#getFreunde()}.
	 * 
	 * @throws Exception
	 */
	@Test
	public void testGetFreunde() throws Exception {
		FreundesListeI fl = new FreundesListeC(ip, port);
		fl.addFreund("Alex");
		fl.addFreund("Antonia");
		fl.addFreund("Martin");
		String[] namen = fl.getFreunde();
		assertTrue("Falsche Anzahl an Freunden", namen.length == 3);
		for (int i = 0; i < namen.length; i++) {
			assertTrue("Enthält ungültige Namen!", (namen[i].equals("Alex")
					|| namen[i].equals("Antonia") || namen[i].equals("Martin")));
		}
	}

	/**
	 * Test method for {@link friendlist.FreundeslisteC#getListennr()}.
	 * 
	 * @throws Exception
	 */
	@Test
	public void testGetListennr() throws Exception {
		fail("not implemented yet");
	}

	/**
	 * Test method for {@link friendlist.FreundeslisteC#getMaxAnzahl()}.
	 * 
	 * @throws Exception
	 */
	@Test
	public void testGetMaxAnzahl() throws Exception {
		FreundesListeI fl = new FreundesListeC(ip, port);
		int alt = fl.getMaxAnzahl();
		fl.addAnzahl(500);
		int neu = fl.getMaxAnzahl();
		assertTrue("Anzahl falsch", alt + 500 == neu);
	}

	/**
	 * Test method for
	 * {@link friendlist.FreundeslisteC#isFreund(java.lang.String)}.
	 * 
	 * @throws Exception
	 */
	@Test
	public void testIsFreund() throws Exception {
		fail("not implemented yet");
	}

}
